
public class Philosopher implements Runnable {
	private Object leftFork;
	private Object rightFork;
	
	public Philosopher(Object leftFork, Object rightFork) {
		this.leftFork = leftFork;
		this.rightFork = rightFork;
	}

	private void doAction(String action) throws InterruptedException {
		//print the action
		System.out.println(Thread.currentThread().getName() + " " + action);
		// performing this action for a random amount of time
		Thread.sleep(((int) (Math.random() * 100)));
	}
	
	@Override
	public void run() {
		try {
			while(true) {
				doAction(System.nanoTime() + ": Thinking");
				synchronized(leftFork) {
					doAction(System.nanoTime() + ": Picked up left fork");
					synchronized(rightFork) {
						doAction(System.nanoTime() + ": Picked up right fork - eating");
						doAction(System.nanoTime() + ": Put down right fork");
					}
					doAction(System.nanoTime() + ": Put down left fork - back to thinking");
				}
			}
		} catch (InterruptedException e) {
			Thread.currentThread().interrupt();
			return;
		}
	}}
